#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{
    int n;
    int o, a, b, ab;

    scanf("%d", &n);
    scanf("%d %d %d %d", &o, &a, &b, &ab);

    int moguce = 0;
    int izlaz[n][4];

    for(int i=0;i<n;i++)
    {
        char pacijentKrvnaGrupa[3];
        int brJedinica;

        scanf("%s %d", &pacijentKrvnaGrupa, &brJedinica);
        if(strcmp(pacijentKrvnaGrupa, "O")==0)
        {
            if(o>=brJedinica)
            {
                moguce++;
                o = o - brJedinica;
                izlaz[i][0] = brJedinica;
                izlaz[i][1] = 0;
                izlaz[i][2] = 0;
                izlaz[i][3] = 0;
            }
            else
            {
                printf("nemoguce\n");
                return 0;
            }
        }
        else if(strcmp(pacijentKrvnaGrupa, "A") == 0)
        {
            int ostatak = 0;
            if(a>=brJedinica)
            {
                moguce++;
                a = a - brJedinica;
                izlaz[i][0] = 0;
                izlaz[i][1] = brJedinica;
                izlaz[i][2] = 0;
                izlaz[i][3] = 0;
            }
            else if((a<brJedinica) && (a > 0))
            {
                ostatak = brJedinica - a;
                if(ostatak<=o)
                {
                    moguce++;
                    o = o - ostatak;
                    izlaz[i][0] = ostatak;
                    izlaz[i][1] = a;
                    izlaz[i][2] = 0;
                    izlaz[i][3] = 0;
                    a = 0;
                }
                else
                {
                    printf("nemoguce\n");
                    return 0;
                }
            }
            else if(a==0 && o>=brJedinica)
            {
                moguce++;
                o = o - brJedinica;
                izlaz[i][0] = brJedinica;
                izlaz[i][1] = 0;
                izlaz[i][2] = 0;
                izlaz[i][3] = 0;

            }
        }
        else if(strcmp(pacijentKrvnaGrupa, "B") == 0)
        {
            int ostatak = 0;
            if(b>=brJedinica)
            {
                moguce++;
                b = b - brJedinica;
                izlaz[i][0] = 0;
                izlaz[i][1] = 0;
                izlaz[i][2] = brJedinica;
                izlaz[i][3] = 0;
            }
            else if((b<brJedinica) && (b > 0))
            {
                ostatak = brJedinica - b;
                if(ostatak<=o)
                {
                    moguce++;
                    o = o - ostatak;
                    izlaz[i][0] = ostatak;
                    izlaz[i][1] = 0;
                    izlaz[i][2] = b;
                    izlaz[i][3] = 0;
                    b = 0;
                }
                else
                {
                    printf("nemoguce\n");
                    return 0;
                }
            }
            else if(b==0 && o>=brJedinica)
            {
                moguce++;
                o = o - brJedinica;
                izlaz[i][0] = brJedinica;
                izlaz[i][1] = 0;
                izlaz[i][2] = 0;
                izlaz[i][3] = 0;
            }
        }
        else if(strcmp(pacijentKrvnaGrupa, "AB") == 0)
        {
            int ostatakAB;
            if(ab >= brJedinica)
            {
                moguce++;
                izlaz[i][0] = 0;
                izlaz[i][1] = 0;
                izlaz[i][2] = 0;
                izlaz[i][3] = brJedinica;
                ab -= brJedinica;
            }
            else if((ab>0) && (ab<=brJedinica))
            {
                ostatakAB = brJedinica - ab;
                if(a >= ostatakAB)
                {
                    moguce++;
                    izlaz[i][0] = 0;
                    izlaz[i][1] = ostatakAB;
                    izlaz[i][2] = 0;
                    izlaz[i][3] = ab;
                    ab = 0;
                    a = a - ostatakAB;
                }
                else if(b >= ostatakAB)
                {
                    moguce++;
                    izlaz[i][0] = 0;
                    izlaz[i][1] = 0;
                    izlaz[i][2] = ostatakAB;
                    izlaz[i][3] = ab;
                    ab = 0;
                    b -= ostatakAB;
                }
                else if(o >= ostatakAB)
                {
                    moguce++;
                    izlaz[i][0] = ostatakAB;
                    izlaz[i][1] = 0;
                    izlaz[i][2] = 0;
                    izlaz[i][3] = ab;
                    ab = 0;
                    o -= ostatakAB;
                }
                else if(a < ostatakAB && b >= brJedinica - ostatakAB)
                {
                    moguce++;
                    izlaz[i][0] = 0;
                    izlaz[i][1] = a;
                    izlaz[i][2] = brJedinica - ostatakAB;
                    izlaz[i][3] = ab;
                    a = 0;
                    b -= brJedinica-ostatakAB;
                }
                else if(a < ostatakAB && o>=brJedinica-ostatakAB)
                {
                    moguce++;
                    izlaz[i][0] = brJedinica-ostatakAB;
                    izlaz[i][1] = a;
                    izlaz[i][2] = 0;
                    izlaz[i][3] = ab;
                    a = 0;
                    o -= brJedinica-ostatakAB;
                }
                else if(a < ostatakAB && b < brJedinica - ostatakAB && o >= brJedinica - (brJedinica - ostatakAB))
                {
                    moguce++;
                    izlaz[i][0] = a;
                    izlaz[i][1] = b;
                    izlaz[i][2] = brJedinica - (brJedinica - ostatakAB);
                    izlaz[i][3] = ab;
                    a = 0;
                    b = 0;
                    o -= brJedinica - (brJedinica - ostatakAB);
                }
                else
                {
                    printf("nemoguce\n");
                    return 0;
                }
            }
        }
    }

    if(moguce == 3)
    {
        printf("moguce\n");
        for(int i=0;i<n;i++)
        {
            printf("%d %d %d %d\n", izlaz[i][0], izlaz[i][1], izlaz[i][2], izlaz[i][3]);
        }
    }

    return 0;
}